Index: branches/HeuristicLab.Problems.GrammaticalOptimization/GrammaticalOptimization.sln
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/GrammaticalOptimization.sln	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/GrammaticalOptimization.sln	(revision 11732)
@@ -13,4 +13,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Common", "HeuristicLab.Common\HeuristicLab.Common.csproj", "{3A2FBBCB-F9DF-4970-87F3-F13337D941AD}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.GrammaticalOptimization.SymbReg", "HeuristicLab.Problems.GrammaticalOptimization.SymbReg\HeuristicLab.Problems.GrammaticalOptimization.SymbReg.csproj", "{17A7A380-86CE-482D-8D22-CBD70CC97F0D}"
 EndProject
 Global
@@ -44,4 +46,8 @@
 		{3A2FBBCB-F9DF-4970-87F3-F13337D941AD}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{3A2FBBCB-F9DF-4970-87F3-F13337D941AD}.Release|Any CPU.Build.0 = Release|Any CPU
+		{17A7A380-86CE-482D-8D22-CBD70CC97F0D}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{17A7A380-86CE-482D-8D22-CBD70CC97F0D}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{17A7A380-86CE-482D-8D22-CBD70CC97F0D}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{17A7A380-86CE-482D-8D22-CBD70CC97F0D}.Release|Any CPU.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/GaussianBandit.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/GaussianBandit.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/GaussianBandit.cs	(revision 11732)
@@ -0,0 +1,49 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public class GaussianBandit : IBandit {
+    public int NumArms { get; private set; }
+    public double OptimalExpectedReward { get; private set; } // reward of the best arm, for calculating regret
+    public int OptimalExpectedRewardArm { get; private set; }
+    public int OptimalMaximalRewardArm { get; private set; }
+
+    private readonly Random random;
+    private readonly double[] exp;
+    private readonly double[] stdDev;
+    public GaussianBandit(Random random, int nArms) {
+      this.random = random;
+      this.NumArms = nArms;
+      // expected reward of arms is iid and uniformly distributed 
+      exp = new double[nArms];
+      stdDev = new double[nArms];
+      OptimalExpectedReward = double.NegativeInfinity;
+      var bestQ = double.NegativeInfinity;
+      for (int i = 0; i < nArms; i++) {
+        exp[i] = Rand.RandNormal(random);  // exp values for arms is N(0,1) distributed
+        stdDev[i] = 1.0 / Rand.GammaRand(random, 1); // variance is inv-gamma distributed 
+        if (exp[i] > OptimalExpectedReward) {
+          OptimalExpectedReward = exp[i];
+          OptimalExpectedRewardArm = i;
+        }
+        var q = alglib.invnormaldistribution(0.99) * stdDev[i] + exp[i];
+        if (q > bestQ) {
+          bestQ = q;
+          OptimalMaximalRewardArm = i;
+        }
+      }
+    }
+
+    // pulling an arm results in a truncated normally distributed reward 
+    // with mean expReward[i] and std.dev 0.1
+    public double Pull(int arm) {
+      var z = Rand.RandNormal(random);
+      var x = z * stdDev[arm] + exp[arm];
+      return x;
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj	(revision 11732)
@@ -31,4 +31,7 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="ALGLIB-3.7.0">
+      <HintPath>..\..\..\trunk\sources\bin\ALGLIB-3.7.0.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
@@ -42,26 +45,48 @@
     <Compile Include="BanditHelper.cs" />
     <Compile Include="Bandits\BernoulliBandit.cs" />
+    <Compile Include="Bandits\GaussianBandit.cs" />
     <Compile Include="Bandits\GaussianMixtureBandit.cs" />
     <Compile Include="Bandits\IBandit.cs" />
     <Compile Include="Bandits\TruncatedNormalBandit.cs" />
+    <Compile Include="OnlineMeanAndVarianceEstimator.cs" />
+    <Compile Include="IPolicyActionInfo.cs" />
     <Compile Include="Models\BernoulliModel.cs" />
     <Compile Include="Models\GaussianModel.cs" />
-    <Compile Include="Models\GaussianMixtureModel.cs" />
     <Compile Include="Models\IModel.cs" />
-    <Compile Include="Policies\BanditPolicy.cs" />
-    <Compile Include="Policies\BernoulliThompsonSamplingPolicy.cs" />
-    <Compile Include="Policies\BoltzmannExplorationPolicy.cs" />
-    <Compile Include="Policies\ChernoffIntervalEstimationPolicy.cs" />
-    <Compile Include="Policies\GenericThompsonSamplingPolicy.cs" />
-    <Compile Include="Policies\ThresholdAscentPolicy.cs" />
-    <Compile Include="Policies\UCTPolicy.cs" />
-    <Compile Include="Policies\GaussianThompsonSamplingPolicy.cs" />
-    <Compile Include="Policies\Exp3Policy.cs" />
-    <Compile Include="Policies\EpsGreedyPolicy.cs" />
+    <Compile Include="Policies\BernoulliThompsonSamplingPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Policies\BoltzmannExplorationPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Policies\ChernoffIntervalEstimationPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Policies\BernoulliPolicyActionInfo.cs" />
+    <Compile Include="Policies\ModelPolicyActionInfo.cs" />
+    <Compile Include="Policies\EpsGreedyPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Policies\GaussianThompsonSamplingPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Policies\GenericThompsonSamplingPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Policies\MeanAndVariancePolicyActionInfo.cs" />
+    <Compile Include="Policies\DefaultPolicyActionInfo.cs" />
+    <Compile Include="Policies\EmptyPolicyActionInfo.cs" />
     <Compile Include="Policies\RandomPolicy.cs" />
     <Compile Include="Policies\UCB1Policy.cs" />
-    <Compile Include="Policies\UCB1TunedPolicy.cs" />
-    <Compile Include="Policies\UCBNormalPolicy.cs" />
     <Compile Include="IPolicy.cs" />
+    <Compile Include="Policies\UCB1TunedPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Policies\UCBNormalPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Policies\UCTPolicy.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicy.cs	(revision 11732)
@@ -8,18 +8,6 @@
   // this interface represents a policy for reinforcement learning
   public interface IPolicy {
-    IEnumerable<int> Actions { get; }
-    int SelectAction(); // action selection ...
-    void UpdateReward(int action, double reward); // ... and reward update are defined as usual
-
-    // policies must also support disabling of potential actions
-    // for instance if we know that an action in a state has a deterministic 
-    // reward we need to sample it only once
-    // it is necessary to sample an action only once
-    void DisableAction(int action);
-
-    // reset causes the policy to be reinitialized to it's initial state (as after constructor-call)
-    void Reset();
-
-    void PrintStats();
+    int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos);
+    IPolicyActionInfo CreateActionInfo();
   }
 }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicyActionInfo.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicyActionInfo.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicyActionInfo.cs	(revision 11732)
@@ -0,0 +1,16 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public interface IPolicyActionInfo {
+    bool Disabled { get; }
+    void UpdateReward(double reward);
+    void Disable();
+    // reset causes the state of the action to be reinitialized (as after constructor-call)
+    void Reset();
+    void PrintStats();
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs	(revision 11732)
@@ -9,7 +9,6 @@
 namespace HeuristicLab.Algorithms.Bandits.Models {
   public class BernoulliModel : IModel {
-    private readonly int numActions;
-    private readonly int[] success;
-    private readonly int[] failure;
+    private int success;
+    private int failure;
 
     // parameters of beta prior distribution
@@ -17,52 +16,34 @@
     private readonly double beta;
 
-    public BernoulliModel(int numActions, double alpha = 1.0, double beta = 1.0) {
-      this.numActions = numActions;
-      this.success = new int[numActions];
-      this.failure = new int[numActions];
+    public BernoulliModel(double alpha = 1.0, double beta = 1.0) {
       this.alpha = alpha;
       this.beta = beta;
     }
 
-
-    public double[] SampleExpectedRewards(Random random) {
+    public double SampleExpectedReward(Random random) {
       // sample bernoulli mean from beta prior
-      var theta = new double[numActions];
-      for (int a = 0; a < numActions; a++) {
-        if (success[a] == -1)
-          theta[a] = 0.0;
-        else {
-          theta[a] = Rand.BetaRand(random, success[a] + alpha, failure[a] + beta);
-        }
-      }
-
-      // no need to sample we know the exact expected value
-      // the expected value of a bernoulli variable is just theta
-      return theta.Select(t => t).ToArray();
+      return Rand.BetaRand(random, success + alpha, failure + beta);
     }
 
-    public void Update(int action, double reward) {
-      const double EPSILON = 1E-6;
-      Debug.Assert(Math.Abs(reward - 0.0) < EPSILON || Math.Abs(reward - 1.0) < EPSILON);
-      if (Math.Abs(reward - 1.0) < EPSILON) {
-        success[action]++;
+    public void Update(double reward) {
+      Debug.Assert(reward.IsAlmost(1.0) || reward.IsAlmost(0.0));
+      if (reward.IsAlmost(1.0)) {
+        success++;
       } else {
-        failure[action]++;
+        failure++;
       }
     }
 
-    public void Disable(int action) {
-      success[action] = -1;
-    }
-
     public void Reset() {
-      Array.Clear(success, 0, numActions);
-      Array.Clear(failure, 0, numActions);
+      success = 0;
+      failure = 0;
     }
 
     public void PrintStats() {
-      for (int i = 0; i < numActions; i++) {
-        Console.Write("{0:F2} ", success[i] / (double)failure[i]);
-      }
+      Console.Write("{0:F2} ", success / (double)failure);
+    }
+
+    public object Clone() {
+      return new BernoulliModel() { failure = this.failure, success = this.success };
     }
   }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs	(revision 11732)
@@ -1,17 +1,11 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.Diagnostics;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
 using HeuristicLab.Common;
 
 namespace HeuristicLab.Algorithms.Bandits.Models {
-  // bayesian estimation of a Gaussian with unknown mean and known variance
+  // bayesian estimation of a Gaussian with 
+  // 1) unknown mean and known variance
+  // 2) unknown mean and unknown variance
   public class GaussianModel : IModel {
-    private readonly int numActions;
-    private readonly int[] tries;
-    private readonly double[] sumRewards;
-
+    private OnlineMeanAndVarianceEstimator estimator = new OnlineMeanAndVarianceEstimator();
 
     // parameters of Gaussian prior for mean
@@ -19,57 +13,104 @@
     private readonly double meanPriorVariance;
 
+    private readonly bool knownVariance;
     private readonly double rewardVariance = 0.1; // assumed know reward variance
 
-    public GaussianModel(int numActions, double meanPriorMu, double meanPriorVariance) {
-      this.numActions = numActions;
-      this.tries = new int[numActions];
-      this.sumRewards = new double[numActions];
+    // parameters of Gamma prior for precision (= inverse variance)
+    private readonly int precisionPriorAlpha;
+    private readonly double precisionPriorBeta;
+
+    // non-informative prior
+    private const double priorK = 1.0;
+
+    // this constructor assumes the variance is known
+    public GaussianModel(double meanPriorMu, double meanPriorVariance, double rewardVariance = 0.1) {
       this.meanPriorMu = meanPriorMu;
       this.meanPriorVariance = meanPriorVariance;
+
+      this.knownVariance = true;
+      this.rewardVariance = rewardVariance;
+    }
+
+    // this constructor assumes the variance is also unknown 
+    // uses Murphy 2007: Conjugate Bayesian analysis of the Gaussian distribution equation 85 - 89
+    public GaussianModel(double meanPriorMu, double meanPriorVariance, int precisionPriorAlpha, double precisionPriorBeta) {
+      this.meanPriorMu = meanPriorMu;
+      this.meanPriorVariance = meanPriorVariance;
+
+      this.knownVariance = false;
+      this.precisionPriorAlpha = precisionPriorAlpha;
+      this.precisionPriorBeta = precisionPriorBeta;
     }
 
 
-    public double[] SampleExpectedRewards(Random random) {
+    public double SampleExpectedReward(Random random) {
+      if (knownVariance) {
+        return SampleExpectedRewardKnownVariance(random);
+      } else {
+        return SampleExpectedRewardUnknownVariance(random);
+      }
+    }
+
+    private double SampleExpectedRewardKnownVariance(Random random) {
       // expected values for reward
-      var theta = new double[numActions];
+      // calculate posterior mean and variance (for mean reward)
 
-      for (int a = 0; a < numActions; a++) {
-        if (tries[a] == -1) {
-          theta[a] = double.NegativeInfinity; // disabled action
-        } else {
-          // calculate posterior mean and variance (for mean reward)
+      // see Murphy 2007: Conjugate Bayesian analysis of the Gaussian distribution (http://www.cs.ubc.ca/~murphyk/Papers/bayesGauss.pdf)
+      var posteriorMeanVariance = 1.0 / (estimator.N / rewardVariance + 1.0 / meanPriorVariance);
+      var posteriorMeanMean = posteriorMeanVariance * (meanPriorMu / meanPriorVariance + estimator.Sum / rewardVariance);
 
-          // see Murphy 2007: Conjugate Bayesian analysis of the Gaussian distribution (http://www.cs.ubc.ca/~murphyk/Papers/bayesGauss.pdf)
-          var posteriorVariance = 1.0 / (tries[a] / rewardVariance + 1.0 / meanPriorVariance);
-          var posteriorMean = posteriorVariance * (meanPriorMu / meanPriorVariance + sumRewards[a] / rewardVariance);
+      // sample a mean from the posterior 
+      var posteriorMeanSample = Rand.RandNormal(random) * Math.Sqrt(posteriorMeanVariance) + posteriorMeanMean;
+      // theta already represents the expected reward value => nothing else to do
+      return posteriorMeanSample;
 
-          // sample a mean from the posterior 
-          theta[a] = Rand.RandNormal(random) * Math.Sqrt(posteriorVariance) + posteriorMean;
-          // theta already represents the expected reward value => nothing else to do
-        }
+      // return 0.99-quantile value
+      //return alglib.invnormaldistribution(0.99) * Math.Sqrt(rewardVariance + posteriorMeanVariance) + posteriorMeanMean;
+    }
+
+    // see Murphy 2007: Conjugate Bayesian analysis of the Gaussian distribution page 6 onwards (http://www.cs.ubc.ca/~murphyk/Papers/bayesGauss.pdf)
+    private double SampleExpectedRewardUnknownVariance(Random random) {
+
+      var posteriorMean = (priorK * meanPriorMu + estimator.Sum) / (priorK + estimator.N);
+      var posteriorK = priorK + estimator.N;
+      var posteriorAlpha = precisionPriorAlpha + estimator.N / 2.0;
+      double posteriorBeta;
+      if (estimator.N > 0) {
+        posteriorBeta = precisionPriorBeta + 0.5 * estimator.N * estimator.Variance + priorK * estimator.N * Math.Pow(estimator.Avg - meanPriorMu, 2) / (2.0 * (priorK + estimator.N));
+      } else {
+        posteriorBeta = precisionPriorBeta;
       }
 
+      // sample from the posterior marginal for mu (expected value) equ. 91
+      // p(µ|D) = T2αn (µ| µn, βn/(αnκn)) 
+
+      // sample from Tk distribution : http://stats.stackexchange.com/a/70270
+      var t2alpha = alglib.invstudenttdistribution((int)(2 * posteriorAlpha), random.NextDouble());
+
+      var theta = t2alpha * posteriorBeta / (posteriorAlpha * posteriorK) + posteriorMean;
       return theta;
+
+      //return alglib.invnormaldistribution(random.NextDouble()) * + theta;
+      //return alglib.invstudenttdistribution((int)(2 * posteriorAlpha), 0.99) * (posteriorBeta*posteriorK + posteriorBeta) / (posteriorAlpha*posteriorK) + posteriorMean;
     }
 
-    public void Update(int action, double reward) {
-      sumRewards[action] += reward;
-      tries[action]++;
-    }
 
-    public void Disable(int action) {
-      tries[action] = -1;
-      sumRewards[action] = 0.0;
+    public void Update(double reward) {
+      estimator.UpdateReward(reward);
     }
 
     public void Reset() {
-      Array.Clear(tries, 0, numActions);
-      Array.Clear(sumRewards, 0, numActions);
+      estimator.Reset();
     }
 
     public void PrintStats() {
-      for (int i = 0; i < numActions; i++) {
-        Console.Write("{0:F2} ", sumRewards[i] / (double)tries[i]);
-      }
+      Console.Write("{0:F2} ", estimator.Avg);
+    }
+
+    public object Clone() {
+      if (knownVariance)
+        return new GaussianModel(meanPriorMu, meanPriorVariance, rewardVariance);
+      else
+        return new GaussianModel(meanPriorMu, meanPriorVariance, precisionPriorAlpha, precisionPriorBeta);
     }
   }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/IModel.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/IModel.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/IModel.cs	(revision 11732)
@@ -6,8 +6,8 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public interface IModel {
-    double[] SampleExpectedRewards(Random random);
-    void Update(int action, double reward);
-    void Disable(int action);
+  // represents a model for the reward distribution (of an action given a state)
+  public interface IModel : ICloneable {
+    double SampleExpectedReward(Random random);
+    void Update(double reward);
     void Reset();
     void PrintStats();
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/OnlineMeanAndVarianceEstimator.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/OnlineMeanAndVarianceEstimator.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/OnlineMeanAndVarianceEstimator.cs	(revision 11732)
@@ -0,0 +1,32 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  class OnlineMeanAndVarianceEstimator {
+    public int N { get; private set; }
+    public double Sum { get; private set; }
+    public double Avg { get; private set; }
+    public double Variance { get { return sampleM2 / N; } }
+    private double sampleM2;
+
+    public void UpdateReward(double reward) {
+      N++;
+      Sum += reward;
+
+      var delta = reward - Avg;
+      Avg += delta / N;
+      sampleM2 += delta * (reward - Avg);
+    }
+
+    public void Reset() {
+      Sum = 0.0;
+      Avg = 0.0;
+      N = 0;
+      sampleM2 = 0.0;
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BanditPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BanditPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BanditPolicy.cs	(revision 11732)
@@ -7,5 +7,5 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public abstract class BanditPolicy : IPolicy {
+  public abstract class BanditPolicy<TPolicyActionInfo> : IPolicy<TPolicyActionInfo> where TPolicyActionInfo : IPolicyActionInfo {
     public IEnumerable<int> Actions { get; private set; }
     private readonly int numInitialActions;
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliPolicyActionInfo.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliPolicyActionInfo.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliPolicyActionInfo.cs	(revision 11732)
@@ -0,0 +1,34 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public class BernoulliPolicyActionInfo : IPolicyActionInfo {
+    public bool Disabled { get { return NumSuccess == -1; } }
+    public int NumSuccess { get; private set; }
+    public int NumFailure { get; private set; }
+    public void UpdateReward(double reward) {
+      Debug.Assert(!Disabled);
+      //Debug.Assert(reward.IsAlmost(0.0) || reward.IsAlmost(1.0));
+
+      //if (reward.IsAlmost(1.0)) NumSuccess++;
+      if (reward > 0) NumSuccess++;
+      else NumFailure++;
+    }
+    public void Disable() {
+      this.NumSuccess = -1;
+      this.NumFailure = -1;
+    }
+    public void Reset() {
+      NumSuccess = 0;
+      NumFailure = 0;
+    }
+    public void PrintStats() {
+      Console.WriteLine("expected value {0,5:F2} disabled {1}", NumSuccess / (double)NumFailure, Disabled);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliThompsonSamplingPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliThompsonSamplingPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliThompsonSamplingPolicy.cs	(revision 11732)
@@ -8,62 +8,32 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class BernoulliThompsonSamplingPolicy : BanditPolicy {
-    private readonly Random random;
-    private readonly int[] success;
-    private readonly int[] failure;
-
+  public class BernoulliThompsonSamplingPolicy : IPolicy {
     // parameters of beta prior distribution
     private readonly double alpha = 1.0;
     private readonly double beta = 1.0;
 
-    public BernoulliThompsonSamplingPolicy(Random random, int numActions)
-      : base(numActions) {
-      this.random = random;
-      this.success = new int[numActions];
-      this.failure = new int[numActions];
-    }
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<BernoulliPolicyActionInfo>(); // TODO: performance
+      int bestAction = -1;
+      double maxTheta = double.NegativeInfinity;
+      var aIdx = -1;
 
-    public override int SelectAction() {
-      Debug.Assert(Actions.Any());
-      var maxTheta = double.NegativeInfinity;
-      int bestAction = -1;
-      foreach (var a in Actions) {
-        var theta = Rand.BetaRand(random, success[a] + alpha, failure[a] + beta);
+      foreach (var aInfo in myActionInfos) {
+        aIdx++;
+        if (aInfo.Disabled) continue;
+        var theta = Rand.BetaRand(random, aInfo.NumSuccess + alpha, aInfo.NumFailure + beta);
         if (theta > maxTheta) {
           maxTheta = theta;
-          bestAction = a;
+          bestAction = aIdx;
         }
       }
+      Debug.Assert(bestAction > -1);
       return bestAction;
     }
 
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-
-      if (reward > 0) success[action]++;
-      else failure[action]++;
+    public IPolicyActionInfo CreateActionInfo() {
+      return new BernoulliPolicyActionInfo();
     }
 
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      success[action] = -1;
-    }
-
-    public override void Reset() {
-      base.Reset();
-      Array.Clear(success, 0, success.Length);
-      Array.Clear(failure, 0, failure.Length);
-    }
-
-    public override void PrintStats() {
-      for (int i = 0; i < success.Length; i++) {
-        if (success[i] >= 0) {
-          Console.Write("{0,5:F2}", success[i] / failure[i]);
-        } else {
-          Console.Write("{0,5}", "");
-        }
-      }
-      Console.WriteLine();
-    }
 
     public override string ToString() {
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BoltzmannExplorationPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BoltzmannExplorationPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BoltzmannExplorationPolicy.cs	(revision 11732)
@@ -5,69 +5,44 @@
 using System.Text;
 using System.Threading.Tasks;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Algorithms.Bandits {
   // also called softmax policy
-  public class BoltzmannExplorationPolicy : BanditPolicy {
-    private readonly Random random;
-    private readonly double eps;
-    private readonly int[] tries;
-    private readonly double[] sumReward;
+  public class BoltzmannExplorationPolicy : IPolicy {
     private readonly double beta;
 
-    public BoltzmannExplorationPolicy(Random random, int numActions, double beta)
-      : base(numActions) {
+    public BoltzmannExplorationPolicy(double beta) {
       if (beta < 0) throw new ArgumentException();
-      this.random = random;
       this.beta = beta;
-      this.tries = new int[numActions];
-      this.sumReward = new double[numActions];
+    }
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      Debug.Assert(actionInfos.Any());
+
+      // select best
+      var myActionInfos = actionInfos.OfType<DefaultPolicyActionInfo>().ToArray(); // TODO: performance
+      Debug.Assert(myActionInfos.Any(a => !a.Disabled));
+      double[] w = new double[myActionInfos.Length];
+
+      for (int a = 0; a < myActionInfos.Length; a++) {
+        if (myActionInfos[a].Disabled) {
+          w[a] = 0; continue;
+        }
+        if (myActionInfos[a].Tries == 0) return a;
+        var sumReward = myActionInfos[a].SumReward;
+        var tries = myActionInfos[a].Tries;
+        var avgReward = sumReward / tries;
+        w[a] = Math.Exp(beta * avgReward);
+      }
+
+
+      var bestAction = Enumerable.Range(0, w.Length).SampleProportional(random, w).First();
+      Debug.Assert(bestAction >= 0);
+      Debug.Assert(bestAction < w.Length);
+      Debug.Assert(!myActionInfos[bestAction].Disabled);
+      return bestAction;
     }
 
-    public override int SelectAction() {
-      Debug.Assert(Actions.Any());
-      // select best
-      var maxReward = double.NegativeInfinity;
-      int bestAction = -1;
-      if (Actions.Any(a => tries[a] == 0))
-        return Actions.First(a => tries[a] == 0);
-
-      var ts = Actions.Select(a => Math.Exp(beta * sumReward[a] / tries[a]));
-      var r = random.NextDouble() * ts.Sum();
-
-      var agg = 0.0;
-      foreach (var p in Actions.Zip(ts, Tuple.Create)) {
-        agg += p.Item2;
-        if (agg >= r) return p.Item1;
-      }
-      throw new InvalidProgramException();
-    }
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-
-      tries[action]++;
-      sumReward[action] += reward;
-    }
-
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      sumReward[action] = 0;
-      tries[action] = -1;
-    }
-
-    public override void Reset() {
-      base.Reset();
-      Array.Clear(tries, 0, tries.Length);
-      Array.Clear(sumReward, 0, sumReward.Length);
-    }
-
-    public override void PrintStats() {
-      for (int i = 0; i < sumReward.Length; i++) {
-        if (tries[i] >= 0) {
-          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
-        } else {
-          Console.Write("{0,5}", "");
-        }
-      }
-      Console.WriteLine();
+    public IPolicyActionInfo CreateActionInfo() {
+      return new DefaultPolicyActionInfo();
     }
 
